;-> HalvePicPlus by Stefano Maria Regattin
;i> 2 Nov 2012
;m> 3 Nov 2012
;m> 10,11 Sep 2019
;m> 9 Feb 2020
;m> 5 Mar 2022
;--------------
AppTitle("HalvePicPlus by Stefano Maria Regattin")
Schermo=Desktop():XLunFinestra=640:YLunFinestra=513:XLunAreaGrafica=620:YLunAreaGrafica=460
Finestra=CreateWindow("HalvePicPlus by Stefano Maria Regattin",Rand(GadgetWidth(Schermo)-XLunFinestra),Rand(GadgetHeight(Schermo)-YLunFinestra),XLunFinestra,YLunFinestra,0,8)
AreaImmagine=CreateCanvas(10,10,XLunAreaGrafica,YLunAreaGrafica,Finestra)
Pannello=CreatePanel(10,10+YLunAreaGrafica+1,XLunAreaGrafica,20,Finestra)
SetPanelColor(Pannello,0,0,127)
BottoneCaricaImmagine=CreateButton("L",1,1,12,GadgetHeight(Pannello)-2,Pannello)
BottoneProcessaImmagine2=CreateButton("/2",1+GadgetWidth(BottoneCaricaImmagine),1,22,GadgetHeight(Pannello)-2,Pannello)
BottoneProcessaImmagine3=CreateButton("/3",1+GadgetWidth(BottoneCaricaImmagine)+GadgetWidth(BottoneProcessaImmagine2),1,22,GadgetHeight(Pannello)-2,Pannello)
BottoneSalvaImmagine=CreateButton("S",GadgetWidth(Pannello)-24,1,12,GadgetHeight(Pannello)-2,Pannello)
BottoneChiudi=CreateButton("Q",GadgetWidth(Pannello)-12,1,12,GadgetHeight(Pannello)-2,Pannello)
BarraProgresso=CreateProgBar(1+GadgetWidth(BottoneCaricaImmagine)+1+(GadgetWidth(BottoneProcessaImmagine2)+1)*2,1,GadgetWidth(Pannello)-1-(GadgetWidth(BottoneCaricaImmagine)+1)*3-(GadgetWidth(BottoneProcessaImmagine2)+1)*2,GadgetHeight(Pannello)-2,Pannello)
SetBuffer(CanvasBuffer(AreaImmagine))
Gosub DisegnaSfondoImmagine
SetStatusText(Finestra,"Welcome to HalvePicPlus!")
MouseWait()
FineDelProgramma=False:ImmagineCaricata=False
Repeat
 SetStatusText(Finestra,"Ready.")
 EventoFinestra=WaitEvent()
 TipoDiEvento=EventSource()
 If EventoFinestra=$401 And TipoDiEvento=BottoneCaricaImmagine Then
  SetStatusText(Finestra,"Loading picture...")
  PercorsoImmagine$=RequestFile("Load a picture...","*bmp;*gif;*jpg;*png")
  If FileType(PercorsoImmagine$)=1 Then
   Immagine=LoadImage(PercorsoImmagine$)
   LarghezzaImmagine=ImageWidth(Immagine)
   AltezzaImmagine=ImageHeight(Immagine)
   SetStatusText(Finestra,"Picture sizes: "+Str(LarghezzaImmagine)+"per"+Str(AltezzaImmagine))
   SetBuffer(CanvasBuffer(AreaImmagine))
   Gosub DisegnaSfondoImmagine
   Color(0,0,0):Rect(0,0,LarghezzaImmagine,AltezzaImmagine,True)
   DrawImage(Immagine,0,0)
   FlipCanvas(AreaImmagine)
   SetStatusText(Finestra,"Picture loaded.")
   ImmagineCaricata=True
  Else
   SetStatusText(Finestra,"Picture not found.")
  EndIf
  Delay(1000)
 EndIf
 If EventoFinestra=$401 And TipoDiEvento=BottoneProcessaImmagine2 Then
  If Immagine>0 Then
   LarghezzaImmagineRidotta=LarghezzaImmagine/2
   AltezzaImmagineRidotta=AltezzaImmagine/2
   ImmagineRidotta=CreateImage(LarghezzaImmagineRidotta,AltezzaImmagineRidotta)
   SetStatusText(Finestra,"Halving image, please wait...")
   For YPosPunto=0 To AltezzaImmagineRidotta-1
    For XPosPunto=0 To LarghezzaImmagineRidotta-1
     SetBuffer(ImageBuffer(Immagine))
     ColorePunto=ReadPixel(XPosPunto*2,YPosPunto*2) And $FFFFFF
     Rosso=ColorePunto/65536 Mod 256
     Verde=ColorePunto/256 Mod 256
     Blu=ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*2+1,YPosPunto*2) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*2,YPosPunto*2+1) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*2+1,YPosPunto*2+1) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     Rosso=Rosso/4:Verde=Verde/4:Blu=Blu/4
     SetBuffer(ImageBuffer(ImmagineRidotta))
     Color(Rosso,Verde,Blu)
     Plot(XPosPunto,YPosPunto)
    Next
    UpdateProgBar(BarraProgresso,YPosPunto*1.0/AltezzaImmagineRidotta)
   Next
   SetBuffer(CanvasBuffer(AreaImmagine))
   Gosub DisegnaSfondoImmagine
   Color(0,0,0):Rect(0,0,LarghezzaImmagineRidotta,AltezzaImmagineRidotta,True)
   DrawImage(ImmagineRidotta,0,0)
   FlipCanvas(AreaImmagine)
   SetStatusText(Finestra,"New picture sizes: "+Str(LarghezzaImmagineRidotta)+"per"+Str(AltezzaImmagineRidotta))
   MouseWait()
   UpdateProgBar(BarraProgresso,0)
   SetStatusText(Finestra,"Picture halved.")
   Immagine=ImmagineRidotta
   LarghezzaImmagine=LarghezzaImmagineRidotta
   AltezzaImmagine=AltezzaImmagineRidotta
  Else
   SetStatusText(Finestra,"You must load a picture first.")
  EndIf
  Delay(1000)
 EndIf
 If EventoFinestra=$401 And TipoDiEvento=BottoneProcessaImmagine3 Then
  If Immagine>0 Then
   LarghezzaImmagineRidotta=LarghezzaImmagine/3
   AltezzaImmagineRidotta=AltezzaImmagine/3
   ImmagineRidotta=CreateImage(LarghezzaImmagineRidotta,AltezzaImmagineRidotta)
   SetStatusText(Finestra,"Halving image, please wait...")
   For YPosPunto=0 To AltezzaImmagineRidotta-1
    For XPosPunto=0 To LarghezzaImmagineRidotta-1
     SetBuffer(ImageBuffer(Immagine))
     ColorePunto=ReadPixel(XPosPunto*3,YPosPunto*3) And $FFFFFF
     Rosso=ColorePunto/65536 Mod 256
     Verde=ColorePunto/256 Mod 256
     Blu=ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3+1,YPosPunto*3) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3+2,YPosPunto*3) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3,YPosPunto*3+1) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3+1,YPosPunto*3+1) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3+2,YPosPunto*3+1) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3,YPosPunto*3+2) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3+1,YPosPunto*3+2) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     ColorePunto=ReadPixel(XPosPunto*3+2,YPosPunto*3+2) And $FFFFFF
     Rosso=Rosso+ColorePunto/65536 Mod 256
     Verde=Verde+ColorePunto/256 Mod 256
     Blu=Blu+ColorePunto Mod 256
     Rosso=Rosso/9:Verde=Verde/9:Blu=Blu/9
     SetBuffer(ImageBuffer(ImmagineRidotta))
     Color(Rosso,Verde,Blu)
     Plot(XPosPunto,YPosPunto)
    Next
    UpdateProgBar(BarraProgresso,YPosPunto*1.0/AltezzaImmagineRidotta)
   Next
   SetBuffer(CanvasBuffer(AreaImmagine))
   Gosub DisegnaSfondoImmagine
   Color(0,0,0):Rect(0,0,LarghezzaImmagineRidotta,AltezzaImmagineRidotta,True)
   DrawImage(ImmagineRidotta,0,0)
   FlipCanvas(AreaImmagine)
   SetStatusText(Finestra,"New picture sizes: "+Str(LarghezzaImmagineRidotta)+"per"+Str(AltezzaImmagineRidotta))
   MouseWait()
   UpdateProgBar(BarraProgresso,0)
   SetStatusText(Finestra,"Picture reduced by one third.")
   Immagine=ImmagineRidotta
   LarghezzaImmagine=LarghezzaImmagineRidotta
   AltezzaImmagine=AltezzaImmagineRidotta
  Else
   SetStatusText(Finestra,"You must load a picture first.")
  EndIf
  Delay(1000)
 EndIf
 If EventoFinestra=$401 And TipoDiEvento=BottoneSalvaImmagine Then
  If ImmagineRidotta>0 Then
   SetStatusText(Finestra,"Saving picture...")
   PercorsoImmagine$=RequestFile("Save the picture...","bmp,jpg,png",True,PercorsoImmagine$)
   If Len(PercorsoImmagine$)>4 And (Right$(PercorsoImmagine$,4)=".bmp" Or Right$(PercorsoImmagine$,4)=".jpg" Or Right$(PercorsoImmagine$,4)=".png") Then
    SaveImage(ImmagineRidotta,PercorsoImmagine$)
    SetStatusText(Finestra,"Picture saved.")
   Else
    SetStatusText(Finestra,"Picture not saved.")
   EndIf
  Else
   SetStatusText(Finestra,"You must load a picture first.")
  EndIf
  Delay(1000)
 EndIf
 If EventoFinestra=$401 And TipoDiEvento=BottoneChiudi Then FineDelProgramma=True
Until FineDelProgramma=True
SetStatusText(Finestra,"Goodbye.")
Delay(1000)
End
.DisegnaSfondoImmagine
 SfumaturaGrigia=False
 For YQuadretto=0 To YLunAreaGrafica-1 Step 20
  For XQuadretto=0 To XLunAreaGrafica-1 Step 20
   If SfumaturaGrigia=False Then
    Color(127,127,127)
   Else
    Color(191,191,191)
   EndIf
   Rect(XQuadretto,YQuadretto,20,20,True)
   SfumaturaGrigia=Not SfumaturaGrigia
  Next
 Next
 FlipCanvas(AreaImmagine)
Return